//---------------------------------------------------------------------------

#pragma hdrstop

#include "uTMyPoint.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
TMyPoint TMyPoint::operator -(TMyPoint &P)
{
	return TMyPoint(x-P.x,y-P.y);
}

TMyPoint TMyPoint::operator +(TMyPoint &P)
{
	return TMyPoint(x+P.x,y+P.y);
}

TMyPoint TMyPoint::operator *(double C)
{
	return TMyPoint(C*x,C*y);
}

TMyPoint TMyPoint::operator /(double C)
{
	return TMyPoint(x/C,y/C);
}

bool TMyPoint::operator ==(TMyPoint &P)
{
	return (x==P.x)&&(y==P.y);
}

bool TMyPoint::operator !=(TMyPoint &P)
{
	return (x!=P.x)||(y!=P.y);
}

double TMyPoint::abs()
{
	return sqrt(x*x+y*y);
}

double TMyPoint::distance_to(TMyPoint &P)
{
	return (P - *this).abs();
}

TMyPoint bissect(TMyPoint O, TMyPoint P1, TMyPoint P2)
{
	TMyPoint Res;
    Res.x = (P1.x+P2.x)/2.0;
    if(P1!=P2 && P2!=O)
    	Res.y = (Res.x-O.x)*(O.distance_to(P1)*(P2.x-O.x)-O.distance_to(P2)*(P1.x-O.x))/(O.distance_to(P2)*(P1.y-O.y)-O.distance_to(P1)*(P2.y-O.y))+O.y;
    else
    {
    	if(P1 == P2) Res = P1;
        else if(P1==O) Res = P2;
        else Res = P1;
    }
    return Res;
}

TMyPoint intersect(TMyPoint l1_p1, TMyPoint l1_p2,TMyPoint l2_p1, TMyPoint l2_p2)
{
	TMyPoint v1 = l1_p2-l1_p1;
    TMyPoint v2 = l2_p2-l2_p1;
    TMyPoint Res;
    try{
    if(((v1.y/v1.x)!=(v2.y/v2.x)))
    {
    	TMyPoint temp = l1_p2+l2_p1-l2_p2-l1_p1;
    	if(temp.x!=0.0)
        {
        	Res = (l1_p2-l1_p1)*(l2_p1.x-l1_p1.x)/temp.x+l1_p1;
        }
        else
        {
        	Res = (l1_p2-l1_p1)*(l2_p1.y-l1_p1.y)/temp.y+l1_p1;
        }
    }
    }
    catch(...)
    {
    	return Res;
    }
    return Res;

}
